#ifndef __quat_to_rot_c /* Copyright Bill.Triggs@inrialpes.fr */
#define __quat_to_rot_c "$ Fri Jul 21 12:12:04 2000 $"
/** NO WARRANTY. Use & distribute freely. Fixes/feedback welcome. **/
/*------------------------------------------------------------------------
  Find the rotation matrix of a quaternion.
 ------------------------------------------------------------------------*/
#include "geom23.h"

double
(*quat_to_rot(double R[3][3], double q[4], int normalize))[3]
{
  if (normalize) {
    double s = 1.0/sqrt(v4sq(q));
    q[X] *= s; q[Y] *= s; q[Z] *= s; q[W] *= s;
  }
  R[X][X] = SQ(q[W])+SQ(q[X])-SQ(q[Y])-SQ(q[Z]);
  R[X][Y] = 2.0*(q[X]*q[Y]-q[Z]*q[W]);
  R[X][Z] = 2.0*(q[W]*q[Y]+q[X]*q[Z]);
  R[Y][X] = 2.0*(q[W]*q[Z]+q[X]*q[Y]);
  R[Y][Y] = SQ(q[W])-SQ(q[X])+SQ(q[Y])-SQ(q[Z]);
  R[Y][Z] = 2.0*(q[Y]*q[Z]-q[W]*q[X]);
  R[Z][X] = 2.0*(q[X]*q[Z]-q[W]*q[Y]);
  R[Z][Y] = 2.0*(q[W]*q[X]+q[Y]*q[Z]);
  R[Z][Z] = SQ(q[W])-SQ(q[X])-SQ(q[Y])+SQ(q[Z]);
  return R;
}

#endif /*__quat_to_rot_c */
